Subject: Re: bug#56185: 29.0.50; imenu with imenu-use-popup-menu fails for *Rescan* item

From: Visuwesh <[email-masked]>
Date: Fri, 24 Jun 2022 18:38:39 +0530

[வெள்ளி ஜூன் 24, 2022] Lars Ingebrigtsen wrote:

> Visuwesh <[email-masked]> writes:
>
>> When imenu-use-popup-menu is non-nil and one selects the *Rescan* item,
>> imenu fails with the following backtrace,
>>
>>     Debugger entered--Lisp error: (error "Invalid `key-parse' syntax: %S" ["*Rescan*"])
>>       lookup-key((keymap "sh" ("*Rescan*" "*Rescan*" . #f(compiled-function () (interactive nil) #<bytecode -0x1823bf90e9c446ac>)) ("x" "x" . #f(compiled-function () (interactive nil) #<bytecode -0x19fbbb6b7dca5348>)) ("y" "y" . #f(compiled-function () (interactive nil) #<bytecode -0x19fbbb6b7da17348>))) ["*Rescan*"])
>>       popup-menu((keymap "sh" ("*Rescan*" "*Rescan*" . #f(compiled-function () (interactive nil) #<bytecode -0x1823bf90e9c446ac>)) ("x" "x" . #f(compiled-function () (interactive nil) #<bytecode -0x19fbbb6b7dca5348>)) ("y" "y" . #f(compiled-function () (interactive nil) #<bytecode -0x19fbbb6b7da17348>))) 105)
>>       imenu--mouse-menu((("*Rescan*" . -99) ("x" . #<marker at 1 in sh>) ("y" . #<marker at 7 in sh>)) 105)
>
> I think something has gone missing here over the years?  Or I'm
> misreading the commits; that's also possible.
>
> We basically end up with this:
>
> (lookup-key
>  '(keymap "sh"
> 	  ("*Rescan*" "*Rescan*" . ignore))
>  ["*Rescan*"])
>
> Which now signals an error; in Emacs 28 it just silently returned nil.
> But the problem here is that that's not a valid menu syntax -- the first
> element should be a symbol, not a string.  So I've now fixed that in
> Emacs 29, which makes this work.  But I'm wondering whether there's
> something more er fundamentally wrong somewhere...

Thanks, it works now but now I'm wondering if the change will pollute
the obarray?  Also can `intern' fail at any point because imenu is also
used by text-modes like org-mode whose heading can have any ol'
character---a quick test in an org file seems to have no problem
however, but I'm interested to know regardless.